// BSUITE.CPP


#include "src/bsuite.h"
#include <conio.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>


const char APP_NAME[] = "Build Game Customization Suite  v0.1a";
const char APP_CPRT[] = "Copyright (c)1999 Jonathon Fowler";


/////////////////////////////////////////////////

// Repaint the screen
void bsDrawScreen(void)
{
	uiClearScreen(DESK_BACK_COLOUR);

	uiDrawSingleBox(1,1,SCREEN_WIDTH,4,1,3);
	uiPrintString(3,2,APP_NAME,1,3);
	uiPrintString(3,3,APP_CPRT,1,3);
}


// Drive the main menu
const char *MainMenuStrings[] = {
		"~!E1E~@xtract Duke Nukem 3D-specific Palettes",
		"~!E1U~@pdate Duke Nukem 3D-specific Palettes",
		"E~!E1X~@tract Build Game Palette",
		"U~!E1P~@date Build Game Palette",
		"~!C1Q~@uit"
	};
#define MAIN_MENU_COUNT	5
#define MAIN_MENU_POSX	15
#define MAIN_MENU_POSY	7
#define MAIN_MENU_WIDE	50
#define MAIN_MENU_HIGH	10

char MainMenuOptions[] = "QEUXP";

void bsMainMenu_Paint(void)
{
	int lp;

	// draw the main menu window
	uiDrawDoubleBox(MAIN_MENU_POSX, MAIN_MENU_POSY,
		MAIN_MENU_WIDE,MAIN_MENU_HIGH,15,1);
	uiPrintString(MAIN_MENU_POSX+2, MAIN_MENU_POSY, " Main Menu ",14,1);

	// place the menu item strings
	for (lp=0; lp<MAIN_MENU_COUNT; lp++)
	{
		if (lp == (MAIN_MENU_COUNT-1))
			uiPrintString(MAIN_MENU_POSX+4,MAIN_MENU_POSY+2+lp+1,
				MainMenuStrings[lp], 15,1);
		else
			uiPrintString(MAIN_MENU_POSX+4,MAIN_MENU_POSY+2+lp,
				MainMenuStrings[lp], 15,1);
	}
}

int bsMainMenu(void)
{
	int option=0, key;
	char *op;

	bsMainMenu_Paint();

	do
	{
		key=toupper(getch());

		if ((op=strchr(MainMenuOptions, key)) != NULL)
			option = op-MainMenuOptions + 1;
		else
			putchar('\a');
	} while (!option);	// while an option is not selected

	// erase the menu
	uiClearRegion(MAIN_MENU_POSX, MAIN_MENU_POSY,
		MAIN_MENU_WIDE,MAIN_MENU_HIGH, DESK_BACK_COLOUR);

	return (option);
}

/////////////////////////////////////////////////